<?php
namespace Teknisa\PLA\Modules\Ciclo\Services;

use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use TecFood\Services\User as UserService;

class pla10000CicloService{

    protected $entityManager;
    protected $environment;

    public function __construct(EntityManager $entityManager, $environment) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
    }
    
    public function insert($row) {
        
        $sqlInsert = "INSERT INTO CNFCARDCICLO (CDCARDCICLO, CDPADCICLO, NRSEQCNFCICLO, CDTIPOPRAT, DSCOMPTPCICLO, IDOPCARDCICLO, NRORDCNFCICLO)
                        VALUES (:CDCARDCICLO, :CDPADCICLO, :NRSEQCNFCICLO, :CDTIPOPRAT, :DSCOMPTPCICLO, :IDOPCARDCICLO, :NRORDCNFCICLO)";
        
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlInsert);
            $std->execute($row);
            
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function update($row) {
        $sqlUpdate = "UPDATE CNFCARDCICLO 
                            SET DSCOMPTPCICLO = :DSCOMPTPCICLO
                                WHERE CDCARDCICLO = :CDCARDCICLO AND CDPADCICLO = :CDPADCICLO AND NRSEQCNFCICLO = :NRSEQCNFCICLO";
        
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlUpdate);
            $std->execute($row);
            
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    
    public function getLastPosition($row) {
        $sqlSelect = "SELECT MAX(NRORDCNFCICLO) AS ID FROM CNFCARDCICLO 
                        WHERE CDCARDCICLO = :CDCARDCICLO
                            AND CDPADCICLO = :CDPADCICLO";
                            
        
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlSelect);
            $std->execute($row);
            $result = $std->fetchAll();
            return $result;
            
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getSequencial($row) {
        $sqlSelect = "SELECT MAX(NRSEQCNFCICLO) AS SEQ FROM CNFCARDCICLO 
                        WHERE CDCARDCICLO = :CDCARDCICLO
                            AND CDPADCICLO = :CDPADCICLO";
                            
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlSelect);
            $std->execute($row);
            $result = $std->fetchAll();
            return $result;
            
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function getSize($row) {
        $sqlSelect = "SELECT COUNT(*) AS TAM FROM CNFCARDCICLO 
                        WHERE CDCARDCICLO = :CDCARDCICLO
                            AND CDPADCICLO = :CDPADCICLO";
        
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlSelect);
            $std->execute($row);
            $result = $std->fetchAll();
            return $result;
            
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getPosition($row) {
        $sqlSelect = "SELECT NRORDCNFCICLO AS POS FROM CNFCARDCICLO 
                        WHERE CDCARDCICLO = :CDCARDCICLO
                            AND CDPADCICLO = :CDPADCICLO
                            AND NRSEQCNFCICLO = :NRSEQCNFCICLO";
        
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlSelect);
            $std->execute($row);
            $result = $std->fetchAll();
            return $result;
            
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function atualizarPosicao($row) {
        $sqlUpdate = "UPDATE CNFCARDCICLO 
                            SET NRORDCNFCICLO = :NRORDCNFCICLO
                                WHERE CDCARDCICLO = :CDCARDCICLO AND CDPADCICLO = :CDPADCICLO AND NRSEQCNFCICLO = :NRSEQCNFCICLO";
        
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlUpdate);
            $std->execute($row);
            
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function delete($row) {
        $sqlDelete = "DELETE FROM CNFCARDCICLO 
                        WHERE CDCARDCICLO = :CDCARDCICLO 
                            AND CDPADCICLO = :CDPADCICLO 
                            AND NRSEQCNFCICLO = :NRSEQCNFCICLO 
                            AND CDTIPOPRAT = :CDTIPOPRAT";
        
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlDelete);
            $std->execute($row);
            
        } catch (Exception $e) {
            throw $e;
        }
    }
}

