<?php
namespace Teknisa\PLA\Modules\Consumo\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Pla02300SetorDoConsumoPorServico extends \Teknisa\GER\Controllers\TeknisaCrud	 {

	protected $dataSourceName;
	protected $parameterBagColumns;
	protected $crudService;
	protected $dataSourceManager;

	public function __construct($crudService, $parameterBag, $dataSourceManager){
			$this->dataSourceManager = $dataSourceManager;
			$this->parameterBag = $parameterBag;
			$this->crudService = $crudService;
			parent::__construct($crudService, $parameterBag);
	}

	public function findParamplaneja(DTO\Request\Filter $request, DTO\Response $response) {
		$this->parameterBagColumns = array('CDFILIAL', 'NRORG');
		$this->dataSourceName = 'pla02300_paramplaneja_setorcoz';
		parent::find($request, $response);
	}

	public function saveParamplaneja(DTO\Request $request, DTO\Response $response){
		$requestRow = $request->getRow();
		$this->dataSourceName = 'paramplaneja';


		$conditions = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $requestRow->get("CDFILIAL")
			)
		);
		
		$filterCriteria = new FilterCriteria($this->dataSourceName, $conditions);
		$newFilterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
		$dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
		$filteredRow = $dataSet->getRows();
		$isEmptyRow = !(bool) count($filteredRow);
		
		$dataSave = array(
			"CDPARPLANEJA" => $isEmptyRow ? 1 : $filteredRow[0]['CDPARPLANEJA'], //CDPARPLANEJA é sempre 1 para novo registro
			"NRORG" => $isEmptyRow ? $requestRow->get('NRORG') : $filteredRow[0]['NRORG'],
			"CDFILIAL" => $isEmptyRow ? $requestRow->get('CDFILIAL') : $filteredRow[0]['CDFILIAL'],
			"CDSETCONFIXO" => $requestRow->get('CDSETCONFIXO'),
			"CDSETCONPERC" => $requestRow->get('CDSETCONPERC'),
			"__is_new" => $isEmptyRow
		);
		
		$dataSave = new DataSet('paramplaneja', array($dataSave));


		$dataSave = new DTO\Request\DataSet($dataSave, $request->getMethod(), $request->getRoutePath(), $request->getUserId());

		parent::save($dataSave, $response);
	}
	
	
	public function verificaNivelProduto(DTO\Request $request, DTO\Response $response) {
		$requestRow = $request->getRow();
		$dataSourceName = 'pla02300_verifica_nivel_produto';
		
		$conditions = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $requestRow['CDFILIAL']
			),
			array(
				"columnName" => "CDARVPROD",
				"operator" => "=",
				"value" => $requestRow['CDARVPROD']
			)
		);
		
		$verifica = $this->crudService->getFilteredDataSet($dataSourceName, $conditions);
		return $response->addDataSet(new DataSet("verificaProduto", $verifica->getRows()));
	}
	
	public function verifyFilialParamplaneja(DTO\Request $request, DTO\Response $response) {
		$requestRow = $request->getRow();
		$dataSourceName = 'paramplaneja';
		
		$conditions = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $requestRow['CDFILIAL']
			)
		);
		
		$verifica = $this->crudService->getFilteredDataSet($dataSourceName, $conditions);
		return $response->addDataSet(new DataSet("verifyFilialParamplaneja", $verifica->getRows()));
	}

	public function findExcecao(DTO\Request\Filter $request, DTO\Response $response) {
		$this->parameterBagColumns = array('CDFILIAL', 'NRORG');
		$this->dataSourceName = 'pla02300_setoprodcons_produto';
		parent::find($request, $response);
	}

	public function saveExcecao(DTO\Request $request, DTO\Response $response) {
		$this->dataSourceName = 'pla02300_setoprodcons';
		parent::save($request, $response);
	}

	public function deleteExcecao(DTO\Request $request, DTO\Response $response) {
		$this->dataSourceName = 'setoprodcons';
		parent::delete($request, $response);
	}

}