<?php

namespace Teknisa\PLA\Modules\Transportadas\Controllers;

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Pla04100Relatorios extends \Zeedhi\Framework\Controller\Report {

    protected $util;
    protected $environment;
    protected $birtStrategy;
    protected $connection;
    protected $crudService;
    protected $dataSourceManager;

    public function __construct(ReportService $reportService, \PLA\Util\Util $util, $environment, $birtStrategy, $connection, $crudService, $dataSourceManager) {
        $this->reportService = $reportService;
        $this->util = $util;
        $this->environment  = $environment;
        $this->birtStrategy = $birtStrategy;
        $this->connection   = $connection;
        $this->crudService  = $crudService;
        $this->dataSourceManager           = $dataSourceManager;
    }

	protected $reportMapping = array (
        'PLA04100' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA04101' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA04102' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA04103' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA04104' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "LISTADESTFILI"   => "L_CDDESTFILI",
                "IDSEMCONSUMO"    => "P_SEMCONSUMO"
            )
        ),
        'PLA04105' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "IDSEMCONSUMO"    => "P_SEMCONSUMO",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA04106' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "IDSEMCONSUMO"    => "P_SEMCONSUMO",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA04107' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "IDSEMCONSUMO"    => "P_SEMCONSUMO",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA04108' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA04109' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "NRORG"           => "NRORG",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA0410A' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA0410B' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        ),
        'PLA0410D' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "LISTASERV"       => "L_CDSERVFILI",
                "CDPRATOINI"      => "P_CDPRATOINI",
                "CDPRATOFIN"      => "P_CDPRATOFIN",
                // "CDFILIAL"        => "P_CDFILIAL",
                "DTINICIAL"       => "P_DTINICIAL",
                "DTFINAL"         => "P_DTFINAL",
                "IDORDEMGRUPSERV" => "P_IDORDEMGRUPSERV",
                "NRORG"           => "NRORG",
                "MASKPLATE"       => "P_MASKPLATE",
                "IDSEMCONSUMO"    => "P_SEMCONSUMO",
                "LISTADESTFILI"   => "L_CDDESTFILI"
            )
        )        
	);

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $positions = '';
        $concatPtEnt = '';

        if ($row['ALLCDFILIAL'] == 'Y' || $row['ALLCDFILIAL'] == 'S') $row['CDFILIAL'] = 'T';
        else $row['CDFILIAL'] = join('_', $row['NMFILIAL']);
        
        if (isset($row['NMGRUPSERV'])) $row['NMGRUPSERV'] = join('_', $row['NMGRUPSERV']);
        else $row['NMGRUPSERV'] = 'T';
        
        if ($row['ALLCDSERVFILI'] == 'Y' || $row['ALLCDSERVFILI'] == 'S') {
            $filiServ = $this->returnFiliServ($row['NMGRUPSERV'], $row['CDFILIAL']);
            foreach ($filiServ as $rowsFiliServ) {
                $positions .= $rowsFiliServ['FILISERV'] . ' ';
            }
            $arrayPositions = explode(' ', $positions);
            array_pop($arrayPositions);
            $row['LISTASERV'] = $this->util->insertLista($arrayPositions);
        } else $row['LISTASERV'] = $this->util->insertLista($row['NMSERVFILI']);
        
        if ($row['ALLPONTOENTREGA'] == 'Y' || $row['ALLPONTOENTREGA'] == 'S') {
            if (isset($row['CDGRUPFILI']) === false) $row['CDGRUPFILI'] = '';
            $pontoEntrega = $this->returnPontosEntrega($row['CDGRUPFILI'], $row['CDFILIAL']);
        } else $pontoEntrega = $row['NMDESTFILI'];
        
        foreach ($pontoEntrega as $rowsPtEntrega) {
            $concatPtEnt .= $rowsPtEntrega['CDFILIAL'] . $rowsPtEntrega['CDDESTFILI'] . ' ';
        }
        $arrayConcat = explode(' ', $concatPtEnt);
        array_pop($arrayConcat);
        $row['LISTADESTFILI'] = $this->util->insertLista($arrayConcat);
        
        $row["NRORG"] = $this->environment->getNrOrg();
        $row['DTINICIAL'] = $row['DTINTERVAL']['start'];
        $row['DTFINAL'] = $row['DTINTERVAL']['end'];
        
        if ($row['IDORDEMGRUPSERV'] == 'Y') $row['IDORDEMGRUPSERV'] = 'S';
        else $row['IDORDEMGRUPSERV'] = 'N';
        
        if (isset($row['CDPRATOINI'])) $row['CDPRATOINI'] = $row['CDPRATOINI'] ? $row['CDPRATOINI'] : '0';
        else $row['CDPRATOINI'] = '0';
       
        if (isset($row['CDPRATOFIN'])) $row['CDPRATOFIN'] = $row['CDPRATOFIN'] ? str_pad($row['CDPRATOFIN'], 10, 'z', STR_PAD_RIGHT) : 'zzzzzzzzzz';
        else $row['CDPRATOFIN'] = 'Z';
        
        $row['MASKPLATE'] = str_replace('*', '@', $row['MASKPLATE']);
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }
    
    private function returnPontosEntrega($grupFili, $filial){
        $conditions = array(
            array(
                'columnName' => 'CDGRUPFILI',
                'operator' => '=',
                'value' => $grupFili
            ),
            array(
                'columnName' => 'P_CDFILIAL',
                'operator' => '=',
                'value' => $filial
            )
        );
        $filterCriteria = new FilterCriteria('pontoEntrega', $conditions);
        $paramBag = array("P_CDFILIAL", "CDGRUPFILI");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $paramBag);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $rows = $dataSet->getRows();
        
        return $rows;
    }
    
    public function returnFiliServ($grupServ, $filial) {
        $filiServConcat = [];
    	$sql = "SELECT SUBSTR(SE.CDFILIAL || SE.CDSERVFILI, 1, 9) AS FILISERV FROM SERVICO SE LEFT JOIN ROTATRANS RO ON SE.CDROTATRANS = RO.CDROTATRANS INNER JOIN FILIAL FL ON SE.CDFILIAL = FL.CDFILIAL WHERE ((INSTR(:P_CDFILIAL, SE.CDFILIAL) <> 0) OR (:P_CDFILIAL  = 'T')) AND ((INSTR(:P_CDGRUPSERV, SE.CDGRUPSERV) <> 0) OR (:P_CDGRUPSERV = 'T')) AND (SE.IDTIPOSERV <> 'A')   AND (SE.IDSERVTRAN = 'S') ORDER BY SE.CDFILIAL, SE.CDSERVFILI";
	
		$params = array(
			"P_CDFILIAL"   => $filial,
			"P_CDGRUPSERV" => $grupServ
		);
		
		$stmt = $this->connection->prepare($sql);
		$stmt->execute($params);
    	$result = $stmt->fetchAll();
		return $result;
    }
    
    private function findAllFilial($grupfili){
        if ($grupfili === '') $grupfili = 'T';
        $conditions = array(
            array(
                'columnName' => 'CDGRUPFILI',
                'operator' => '=',
                'value' => $grupfili
            ),
            array(
                'columnName' => 'CDOPERADOR',
                'operator' => '=',
                'value' => $this->environment->getCdOperador()
            ),
            array(
                'columnName' => 'NRORG',
                'operator' => '=',
                'value' => $this->environment->getNrOrg()
            )
        );
        $filterCriteria = new FilterCriteria('filial_operador_grupfili', $conditions);
        $paramBag = array("NRORG", "CDOPERADOR", "CDGRUPFILI");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $paramBag);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $rows = $dataSet->getRows();

        $concatFiliais = '_';
        foreach($rows as $filial){
            $concatFiliais = $concatFiliais.$filial['CDFILIAL'].'_';
        }
        return $concatFiliais;
    }
    
}